package by.zerg.cashoutcalculator.model;

import by.zerg.cashoutcalculator.helpers.ArrayHelper;

public class ATM {
	private final String name;
	private final Currency currency;
	private final Integer[] loading;

	public ATM(String name, Currency currency, Integer[] loading) {
		this.name = name;
		this.currency = currency;
		this.loading = loading;
	}

	@Override
	public String toString() {
		return ArrayHelper.valueOf(loading);
	}

	public double calculateRake(Card card, double amount) {
		double rest = amount;
		double rake = 0;
		double tr = 0;

		while (rest != 0) {
			tr = rest;
			for (int trs : loading) {
				if (trs <= rest) {
					tr = trs;
				}
			}
			rake += Math.max(card.getMinAtmRake(),
					Math.min(card.getMaxAtmRake(), card.getAtmRake() * tr));
			rest -= tr;
		}

		return rake;
	}

	public String getName() {
		return name;
	}

	public Currency getCurrency() {
		return currency;
	}

	public Integer[] getLoading() {
		return loading;
	}
}
