package by.zerg.cashoutcalculator.model;

import by.zerg.cashoutcalculator.config.Config;

public class Card {
	private final String name;
	private final Currency currency;
	private final String type;
	private final double atmRake;
	private final double minAtmRake;
	private final double maxAtmRake;
	private final double cardRake;
	private final double minCardRake;
	private final double maxCardRake;
	private final double systemRake;
	private final double minSystemRake;
	private final double maxSystemRake;

	public Card(String name, Currency currency, String type, double atmRake,
			double minAtmRake, double maxAtmRake, double cardRake,
			double minCardRake, double maxCardRake, double systemRake,
			double minSystemRake, double maxSystemRake) {
		this.name = name;
		this.currency = currency;
		this.type = type;
		this.atmRake = atmRake;
		this.minAtmRake = minAtmRake;
		this.maxAtmRake = maxAtmRake;
		this.cardRake = cardRake;
		this.minCardRake = minCardRake;
		this.maxCardRake = maxCardRake;
		this.systemRake = systemRake;
		this.minSystemRake = minSystemRake;
		this.maxSystemRake = maxSystemRake;
	}

	public static Card valueOf(String name) {
		Card result = null;
		for (Card card : Config.getCards()) {
			if (card.getName().equals(name)) {
				result = card;
				break;
			}
		}
		return result;
	}

	@Override
	public String toString() {
		return name + " " + type;
	}

	public String getName() {
		return name;
	}

	public Currency getCurrency() {
		return currency;
	}

	public String getType() {
		return type;
	}

	public double getAtmRake() {
		return atmRake;
	}

	public double getMinAtmRake() {
		return minAtmRake;
	}

	public double getMaxAtmRake() {
		return maxAtmRake;
	}

	public double getCardRake() {
		return cardRake;
	}

	public double getMinCardRake() {
		return minCardRake;
	}

	public double getMaxCardRake() {
		return maxCardRake;
	}

	public double getSystemRake() {
		return systemRake;
	}

	public double getMinSystemRake() {
		return minSystemRake;
	}

	public double getMaxSystemRake() {
		return maxSystemRake;
	}
}
