package by.zerg.cashoutcalculator.model;

public class CashoutCalculatorImpl implements CashoutCalculator {
	private Card card;
	private ATM atm;

	public CashoutCalculatorImpl() {
		// TODO Auto-generated constructor stub
	}

	@Override
	public void setATM(ATM atm) {
		this.atm = atm;
	}

	@Override
	public void setCard(Card card) {
		this.card = card;
	}

	@Override
	public double calculate(double amount) {
		double totalAtmRake = atm.calculateRake(card, amount);
		double totalAtmAmount = amount + totalAtmRake;
		double totalCardRake = Math.max(
				card.getMinCardRake(),
				Math.min(card.getMaxCardRake(), card.getCardRake()
						* totalAtmAmount));
		double totalCardAmount = totalAtmAmount + totalCardRake;
		double totalSystemRake = Math.max(
				card.getMinSystemRake(),
				Math.min(card.getMaxSystemRake(), card.getSystemRake()
						* totalCardAmount));
		double totalSystemAmount = totalCardAmount + totalSystemRake;
		double totalWebmoneyRake = Math.min(MAX_WEBMONEY_RAKE, WEBMONEY_RAKE
				* totalSystemAmount);
		double totalWebmoneyAmount = totalSystemAmount + totalWebmoneyRake;
		return totalWebmoneyAmount;
	}

	@Override
	public double calculateCommissionRate(double amount) {
		double commissionRate = calculate(amount) / amount - 1;
		return commissionRate;
	}
}
